/*
    Copyright (c) 2002, 2003, bDistributed.com, Inc.
    All rights reserved.

    Redistribution and use in source and binary forms, with or
    without modification, are permitted provided that the following
    conditions are met:

    *   Redistributions of source code must retain the above
        copyright notice, this list of conditions and the following
        disclaimer.
    
    *   Redistributions in binary form must reproduce the above
        copyright notice, this list of conditions and the following
        disclaimer in the documentation and/or other materials
        provided with the distribution.
    
    *   Neither the name of bDistributed.com, Inc. nor the names of
        its contributors may be used to endorse or promote products
        derived from this software without specific prior written
        permission.

    THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND
    CONTRIBUTORS ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES,
    INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
    MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
    DISCLAIMED. IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE
    LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
    OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
    PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA,
    OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
    THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR
    TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT
    OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY
    OF SUCH DAMAGE.
*/

#import "Person.h"


@implementation Person

- (id)initWithFirstName:(NSString *)firstName
               lastName:(NSString *)lastName
                    sex:(NSString *)sex
                    age:(int)age
{
    if (self = [super init]) {
        [self setFirstName:firstName];
        [self setLastName:lastName];
        [self setSex:sex];
        [self setAge:age];
    }
    return self;
}

- (void)dealloc
{
    [_firstName release];
    [_lastName release];
    [_sex release];
    
    [super dealloc];
}

- (void)setFirstName:(NSString *)value
{
    if (_firstName != value) {
        NSString *temp = [value copy];
        [_firstName autorelease];
        _firstName = temp;
    }
}

- (NSString *)firstName
{
    return [[_firstName retain] autorelease];
}

- (void)setLastName:(NSString *)value
{
    if (_lastName != value) {
        NSString *temp = [value copy];
        [_lastName autorelease];
        _lastName = temp;
    }
}

- (NSString *)lastName
{
    return [[_lastName retain] autorelease];
}

- (void)setSex:(NSString *)value
{
    if (_sex != value) {
        NSString *temp = [value copy];
        [_sex autorelease];
        _sex = temp;
    }
}

- (NSString *)sex
{
    return [[_sex retain] autorelease];
}

- (void)setAge:(int)value
{
    if (_age != value) {
        _age = value;
    }
}

- (int)age
{
    return _age;
}

+ (id)personWithFirstName:(NSString *)firstName
                 lastName:(NSString *)lastName
                      sex:(NSString *)sex
                      age:(int)age
{
    return [[[Person alloc] initWithFirstName:firstName
                                     lastName:lastName
                                          sex:sex
                                          age:age] autorelease];
}

@end
